## mini-init-asm 0.1.0

=== Makefile ===
# Build configuration
BUILD_DIR        ?= build
INC_DIR          := include

TARGET_AMD64     ?= mini-init-amd64
TARGET_ARM64     ?= mini-init-arm64

AMD64_SRC_DIR    := src/amd64
ARM64_SRC_DIR    := src/arm64

NASM             := nasm
LD               := ld
NASMFLAGS        := -f elf64 -I$(INC_DIR)/ -g -F dwarf
LDFLAGS          := -nostdlib -z noexecstack

ARM64_AS         ?= aarch64-linux-gnu-as
ARM64_LD         ?= aarch64-linux-gnu-ld
ARM64_ASFLAGS    ?= -g
ARM64_LDFLAGS    ?= -nostdlib -z noexecstack

AMD64_BUILD_DIR  := $(BUILD_DIR)/amd64
ARM64_BUILD_DIR  := $(BUILD_DIR)/arm64

AMD64_SRCS       := main.asm signals.asm spawn.asm forward.asm wait.asm epoll.asm timer.asm log.asm time.asm
AMD64_OBJS       := $(addprefix $(AMD64_BUILD_DIR)/,$(AMD64_SRCS:.asm=.o))

ARM64_SRCS       := main.S signals.S spawn.S forward.S wait.S epoll.S timer.S log.S time.S util.S
ARM64_OBJS       := $(addprefix $(ARM64_BUILD_DIR)/,$(ARM64_SRCS:.S=.o))

.PHONY: helper-arm64
ARM64_HELPERS_SRCS := helpers/exit42.S helpers/sleeper.S
ARM64_HELPERS_OBJS := $(addprefix $(ARM64_BUILD_DIR)/,$(ARM64_HELPERS_SRCS:.S=.o))
ARM64_HELPERS_BINS := $(ARM64_BUILD_DIR)/helper-exit42 $(ARM64_BUILD_DIR)/helper-sleeper

.PHONY: all all-amd64 build-arm64 clean test test-amd64 test-arm64 test-all

all: all-amd64

all-amd64: $(BUILD_DIR)/$(TARGET_AMD64)

build-arm64: $(BUILD_DIR)/$(TARGET_ARM64) $(ARM64_HELPERS_BINS)

build-amd64: $(BUILD_DIR)/$(TARGET_AMD64)

test: test-amd64

test-amd64: $(BUILD_DIR)/$(TARGET_AMD64)
	bash scripts/test_harness.sh $(BUILD_DIR)/$(TARGET_AMD64)

test-arm64: $(BUILD_DIR)/$(TARGET_ARM64)
	bash scripts/test_harness_arm64.sh $(BUILD_DIR)/$(TARGET_ARM64)

test-all: test-amd64
	bash scripts/test_ep_signals.sh $(BUILD_DIR)/$(TARGET_AMD64)
	bash scripts/test_edge_cases.sh $(BUILD_DIR)/$(TARGET_AMD64)
	bash scripts/test_exit_code_mapping.sh $(BUILD_DIR)/$(TARGET_AMD64)
	bash scripts/test_restart.sh $(BUILD_DIR)/$(TARGET_AMD64)

$(AMD64_BUILD_DIR):
	mkdir -p $@

$(ARM64_BUILD_DIR):
	mkdir -p $@

$(AMD64_BUILD_DIR)/%.o: $(AMD64_SRC_DIR)/%.asm | $(AMD64_BUILD_DIR)
	$(NASM) $(NASMFLAGS) $< -o $@

$(ARM64_BUILD_DIR)/%.o: $(ARM64_SRC_DIR)/%.S | $(ARM64_BUILD_DIR)
	$(ARM64_AS) $(ARM64_ASFLAGS) -I$(INC_DIR) $< -o $@

# Helper objects
$(ARM64_BUILD_DIR)/helpers/%.o: $(ARM64_SRC_DIR)/helpers/%.S | $(ARM64_BUILD_DIR)
	mkdir -p $(ARM64_BUILD_DIR)/helpers
	$(ARM64_AS) $(ARM64_ASFLAGS) -I$(INC_DIR) $< -o $@

$(BUILD_DIR)/$(TARGET_AMD64): $(AMD64_OBJS)
	$(LD) $(LDFLAGS) -o $@ $(AMD64_OBJS)

$(BUILD_DIR)/$(TARGET_ARM64): $(ARM64_OBJS)
	$(ARM64_LD) $(ARM64_LDFLAGS) -o $@ $(ARM64_OBJS)

# Helper binaries (linked standalone)
$(ARM64_BUILD_DIR)/helper-exit42: $(ARM64_BUILD_DIR)/helpers/exit42.o
	$(ARM64_LD) $(ARM64_LDFLAGS) -o $@ $<

$(ARM64_BUILD_DIR)/helper-sleeper: $(ARM64_BUILD_DIR)/helpers/sleeper.o
	$(ARM64_LD) $(ARM64_LDFLAGS) -o $@ $<

clean:
	rm -rf $(BUILD_DIR)

=== debian/changelog ===
mini-init-asm (0.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1122134)

 -- Alex Myczko <tar@debian.org>  Sun, 07 Dec 2025 14:02:33 +0000

## mini-init-asm 0.3.1+ds

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,6 @@
 # Build configuration
+VERSION          := $(shell cat VERSION 2>/dev/null || echo "unknown")
+
 BUILD_DIR        ?= build
 INC_DIR          := include
 
@@ -10,13 +12,31 @@
 
 NASM             := nasm
 LD               := ld
-NASMFLAGS        := -f elf64 -I$(INC_DIR)/ -g -F dwarf
-LDFLAGS          := -nostdlib -z noexecstack
+DEBUG            ?= 1
 
-ARM64_AS         ?= aarch64-linux-gnu-as
-ARM64_LD         ?= aarch64-linux-gnu-ld
-ARM64_ASFLAGS    ?= -g
-ARM64_LDFLAGS    ?= -nostdlib -z noexecstack
+NASMFLAGS        := -f elf64 -I$(INC_DIR)/
+LDFLAGS          := -nostdlib -z noexecstack -z relro -z now --build-id=sha1
+
+ARM64_AS         ?= $(shell command -v aarch64-linux-gnu-as 2>/dev/null || echo as)
+ARM64_LD         ?= $(shell command -v aarch64-linux-gnu-ld 2>/dev/null || echo ld)
+ARM64_ASFLAGS    ?= -I$(INC_DIR)
+ARM64_LDFLAGS    ?= -nostdlib -z noexecstack -z relro -z now --build-id=sha1
+
+ifeq ($(DEBUG),1)
+NASMFLAGS        += -g -F dwarf
+ARM64_ASFLAGS    += -g
+endif
+
+# Generate version include files for both architectures
+$(INC_DIR)/version_amd64.inc: VERSION
+	@echo '; Auto-generated version file' > $@
+	@echo 'version_msg_str: db "mini-init-amd64 $(VERSION)", 10, 0' >> $@
+	@echo 'version_msg_len_val: equ $$ - version_msg_str - 1' >> $@
+
+$(INC_DIR)/version_arm64.inc: VERSION
+	@echo '// Auto-generated version file' > $@
+	@echo 'version_msg_arm64: .asciz "mini-init-arm64 $(VERSION)\n"' >> $@
+	@echo '.equ version_msg_arm64_len, . - version_msg_arm64 - 1' >> $@
 
 AMD64_BUILD_DIR  := $(BUILD_DIR)/amd64
 ARM64_BUILD_DIR  := $(BUILD_DIR)/arm64
@@ -55,6 +75,7 @@
 	bash scripts/test_edge_cases.sh $(BUILD_DIR)/$(TARGET_AMD64)
 	bash scripts/test_exit_code_mapping.sh $(BUILD_DIR)/$(TARGET_AMD64)
 	bash scripts/test_restart.sh $(BUILD_DIR)/$(TARGET_AMD64)
+	bash scripts/test_diagnostics.sh $(BUILD_DIR)/$(TARGET_AMD64)
 
 $(AMD64_BUILD_DIR):
 	mkdir -p $@
@@ -62,14 +83,14 @@
 $(ARM64_BUILD_DIR):
 	mkdir -p $@
 
-$(AMD64_BUILD_DIR)/%.o: $(AMD64_SRC_DIR)/%.asm | $(AMD64_BUILD_DIR)
+$(AMD64_BUILD_DIR)/%.o: $(AMD64_SRC_DIR)/%.asm $(INC_DIR)/*.inc $(INC_DIR)/version_amd64.inc | $(AMD64_BUILD_DIR)
 	$(NASM) $(NASMFLAGS) $< -o $@
 
-$(ARM64_BUILD_DIR)/%.o: $(ARM64_SRC_DIR)/%.S | $(ARM64_BUILD_DIR)
-	$(ARM64_AS) $(ARM64_ASFLAGS) -I$(INC_DIR) $< -o $@
+$(ARM64_BUILD_DIR)/%.o: $(ARM64_SRC_DIR)/%.S $(INC_DIR)/*.inc $(INC_DIR)/version_arm64.inc | $(ARM64_BUILD_DIR)
+	$(ARM64_AS) $(ARM64_ASFLAGS) $< -o $@
 
 # Helper objects
-$(ARM64_BUILD_DIR)/helpers/%.o: $(ARM64_SRC_DIR)/helpers/%.S | $(ARM64_BUILD_DIR)
+$(ARM64_BUILD_DIR)/helpers/%.o: $(ARM64_SRC_DIR)/helpers/%.S $(INC_DIR)/*.inc | $(ARM64_BUILD_DIR)
 	mkdir -p $(ARM64_BUILD_DIR)/helpers
 	$(ARM64_AS) $(ARM64_ASFLAGS) -I$(INC_DIR) $< -o $@

=== debian/changelog ===
mini-init-asm (0.3.1+ds-3) unstable; urgency=medium

  * Add upstream co-maintainer to Uploaders.
  * debian/control:
    - bump Standards-Version to 4.7.3.
  * debian/watch: add upstream/debian version mangling for v-prefixed tags
    and +ds repacks.
  * debian/rules + debian/install:
    - install a unified binary path as /usr/bin/mini-init-asm.
  * debian/mini-init-asm.lintian-overrides: fix override context to match the
    installed binary path.
  * debian/mini-init-asm.manpages: install mini-init-asm(1).

 -- Bogdan Pedchenko <m0980701299@gmail.com>  Mon, 23 Feb 2026 19:58:00 +0000

mini-init-asm (0.3.1+ds-2) unstable; urgency=medium

  * d/rules: fix build on amd64.

 -- Alex Myczko <tar@debian.org>  Mon, 16 Feb 2026 22:51:11 +0000

mini-init-asm (0.3.1+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright:
    - relicense debian/* to upstream license.
    - bump years.

 -- Alex Myczko <tar@debian.org>  Mon, 16 Feb 2026 19:42:48 +0000

=== debian/control ===
Source: mini-init-asm
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Uploaders: Bogdan Pedchenko <m0980701299@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 nasm,
Standards-Version: 4.7.3
Homepage: https://github.com/roots666/mini-init-asm
Vcs-Browser: https://salsa.debian.org/debian/mini-init-asm
Vcs-Git: https://salsa.debian.org/debian/mini-init-asm.git

Package: mini-init-asm
Architecture: arm64 amd64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: tiny PID 1 for containers
 This spawns your target process as its own process group, forwards signals to
 the whole group, reaps zombies, and optionally restarts your app on crash. On
 exit, it returns your app's status code (with configurable signal→exit
 mapping).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_build:
ifeq ($(DEB_BUILD_ARCH), arm64)
	$(MAKE) build-arm64
	cp build/mini-init-arm64 build/mini-init-asm
else
	$(MAKE) build-amd64
	cp build/mini-init-amd64 build/mini-init-asm
endif

override_dh_auto_test:
	@echo moo

=== debian/watch ===
Version: 5
Template: GitHub
Owner: roots666
Project: mini-init-asm
Uversion-Mangle: s/^v//
Dversion-Mangle: s/\+ds\d*$//
